---
openapi: 3.0.3
info:
  title: Braze REST API – Export KPIs for daily app uninstalls by date
  description: 'Use this endpoint to retrieve a daily series of the total number of uninstalls on each date.

    '
  version: 1.0.0
  contact:
    name: Braze Support
    url: https://www.braze.com/docs/braze_support/
  license:
    name: Braze Documentation
    url: https://www.braze.com/docs/api/home/
servers:
  - url: https://rest.iad-01.braze.com
    description: US-01
  - url: https://rest.iad-02.braze.com
    description: US-02
  - url: https://rest.iad-03.braze.com
    description: US-03
  - url: https://rest.iad-04.braze.com
    description: US-04
  - url: https://rest.iad-05.braze.com
    description: US-05
  - url: https://rest.iad-06.braze.com
    description: US-06
  - url: https://rest.iad-07.braze.com
    description: US-07
  - url: https://rest.iad-08.braze.com
    description: US-08
  - url: https://rest.us-10.braze.com
    description: US-10
  - url: https://rest.fra-01.braze.eu
    description: EU-01
  - url: https://rest.fra-02.braze.eu
    description: EU-02
  - url: https://rest.au-01.braze.com
    description: AU-01
  - url: https://rest.id-01.braze.com
    description: ID-01
  - url: https://rest.jp-01.braze.com
    description: JP-01
  - url: https://rest.kr-01.braze.com
    description: KR-01
security:
- BearerAuth: []
paths:
  "/kpi/uninstalls/data_series":
    get:
      summary: Export KPIs for daily app uninstalls by date
      description: |
        ## Prerequisites

        To use this endpoint, you'll need an [API key]({{site.baseurl}}/api/basics#rest-api-key-permissions) with the `kpi.uninstalls.data_series` permission.

        ## Rate limit

        We apply the default Braze rate limit of 250,000 requests per hour to this endpoint, as documented in [API rate limits]({{site.baseurl}}/api/api_limits/).

        ## Request parameters

        The following table lists the request parameters for this endpoint.

        | Parameter| Required | Data Type | Description |
        | -------- | -------- | --------- | ----------- |
        | `length` | Required | Integer | Maximum number of days before `ending_at` to include in the returned series. Must be between 1 and 100 (inclusive). |
        | `ending_at` | Optional | Datetime <br>([ISO-8601](https://en.wikipedia.org/wiki/ISO_8601) string) | Date on which the data series should end. Defaults to time of the request. |
        | `app_id` | Optional | String | App API identifier retrieved from the [API Keys]({{site.baseurl}}/user_guide/administer/global/workspace_settings/apis_and_identifiers/) page. If excluded, results for all apps in workspace will be returned. |


        ## Example request

        The following sample request shows an example of how to export KPIs for daily app uninstalls by date.

        ```
        curl --location -g --request GET 'https://rest.iad-01.braze.com/kpi/uninstalls/data_series?length=14&ending_at=2018-06-28T23:59:59-5:00&app_id={{app_identifier}}' \
        --header 'Authorization: Bearer YOUR_REST_API_KEY'
        ```


        ## Response

        The following sample response shows an example of the response returned when you export KPIs for daily app uninstalls by date.

        ```json
        {
            "message": (string) returns 'success' when the request completes without errors,
            "data" : [
                {
                    "time" : (string) the date as ISO 8601 date,
                    "uninstalls" : (int) the number of uninstalls
                },
                ...
            ]
        }
        ```

        For export troubleshooting, see the export troubleshooting guidance.

        ## Response status codes

        The following table lists the responses for this endpoint, the error message you may receive, and how to resolve it.

        | Status code | Meaning | Error message | How to resolve |
        | --- | --- | --- | --- |
        | `200 OK` | The request succeeded and the response body includes the requested data. | `success` | No action needed. |
        | `400 Bad Request` | The `length` is missing, isn't an integer, or is out of range. | `an integer length must be provided`<br>`series range must be greater than 0 and less than 100` | Pass an integer `length` between 1 and 100. |
        | `400 Bad Request` | The `ending_at` value is improperly formatted or out of range. | `ending_at time is improperly formatted`<br>`ending_at time is out of range` | Provide `ending_at` as an ISO-8601 datetime that isn't in the future or before the year 2000. |
        | `400 Bad Request` | The `app_id` value isn't a valid app API key for this workspace. | `app_id must be a valid app api key for this app group` | Pass a valid `app_id` from the API Keys page, or omit it. |
        | `401 Unauthorized` | The REST API key is missing, malformed, or sent to the wrong REST endpoint. | `Invalid API key` | Send the key as `Authorization: Bearer YOUR_REST_API_KEY` to the correct [REST endpoint]({{site.baseurl}}/api/basics/#endpoints). For more causes, see [Errors and responses]({{site.baseurl}}/api/errors/#fatal-errors). |
        | `403 Access Denied` | The REST API key doesn't have the required permission. | `Access Denied` | Use a REST API key that has the `kpi.uninstalls.data_series` permission. |
        | `429 Rate Limited` | You exceeded the rate limit for this endpoint. | `Over rate limit` | Slow your request rate and retry with exponential backoff. See [API rate limits]({{site.baseurl}}/api/api_limits/). |
        | `5XX Internal Server Error` | An unexpected error occurred on the Braze server. | `Internal Server Error` | Retry with exponential backoff. If the error persists, contact [Support]({{site.baseurl}}/braze_support/). |
      operationId: get_kpi_uninstalls_data_series_get_kpi_uninstalls_date
      tags:
      - Export
      responses:
        '200':
          description: The request succeeded and the response body includes the requested data.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/KpiUninstallsDateResponse'
        '400':
          description: |-
            Bad Request. Causes include:

            - The `length` is missing, isn't an integer, or is out of range.
            - The `ending_at` value is improperly formatted or out of range.
            - `app_id must be a valid app api key for this app group` — The `app_id` value isn't a valid app API key for this workspace.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: The REST API key is missing, malformed, or sent to the wrong REST endpoint.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '403':
          description: The REST API key doesn't have the required permission.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '429':
          description: You exceeded the rate limit for this endpoint.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '5XX':
          description: An unexpected error occurred on the Braze server.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      parameters:
      - name: length
        in: query
        required: true
        description: Maximum number of days before `ending_at` to include in the returned series. Must be between 1 and 100 (inclusive).
        schema:
          type: integer
      - name: ending_at
        in: query
        required: false
        description: Date on which the data series should end. Defaults to time of the request.
        schema:
          type: string
      - name: app_id
        in: query
        required: false
        description: App API identifier retrieved from the API Keys page. If excluded, results for all apps in workspace will be returned.
        schema:
          type: string
components:
  schemas:
    KpiUninstallsDateResponse:
      type: object
      properties:
        message:
          type: string
          description: Returns 'success' when the request completes without errors.
        data:
          type: array
          items:
            type: object
            properties:
              time:
                type: string
                description: The date as ISO 8601 date.
              uninstalls:
                type: integer
                description: The number of uninstalls.
    ErrorResponse:
      type: object
      properties:
        message:
          type: string
          description: The error message describing why the request failed.
        errors:
          type: array
          description: Non-fatal errors encountered while processing the request. Data unaffected by these errors is still processed.
          items:
            type: object
            properties:
              type:
                type: string
                description: The error type.
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: REST API key
